//start paddle 1 on left, paddle 2 on right
//  head can bounce off either paddle
//  this way, one player can play alone, or both together
//screen left = 8, screen right = 247, paddle width = 24, paddle y = 216

//source file for Head Bounce game
bounce_main:
	gosub bounce_initvars
	gosub bounce_loadbg
bounce_mainloop:
	if bounce_loseball = 1 gosub bounce_lost_ball
	gosub bounce_joyhandler
	gosub bounce_physics
	gosub bounce_draw
	if bounce_endgame = 0 branchto bounce_mainloop
//show endscreen
//	set $2006 $21
//	set $2006 $cb
	
//	set $2007 71 // g
//	set $2007 65 // a
//	set $2007 77 // m
//	set $2007 69 // e
//	set $2007 32
//	set $2007 79 // o
//	set $2007 86 // v
//	set $2007 69 // e
//	set $2007 82 // r
	set x 0
	//set y 64
	set $2003 64
	bounce_endscreen:
		//set a [bounce_endscreen_data y]
		//set [spritemem x] a
		set $2004 [bounce_endscreen_data x]
		inc x
		//inc y
		if x <> 32 branchto bounce_endscreen
	//set [spritemem 64]
	set bounce_endtimer 90
	gosub vwait
	//set SPRITE_DMA 2
	set $2005 bounce_scroll
	set $2005 0
bounce_endloop: //wait a bit before exiting
	gosub vwait
	set $2005 bounce_scroll
	set $2005 0
	dec bounce_endtimer
	if bounce_endtimer <> 0 branchto bounce_endloop
	return

bounce_endscreen_data:
	asm
	.db 96, 71, 0, 96	;//g
	.db 96, 65, 0, 104	;//a
	.db 96, 77, 0, 112	;//m
	.db 96, 69, 0, 120	;//e

	.db 96, 79, 0, 132	;//o
	.db 96, 86, 0, 140	;//v
	.db 96, 69, 0, 148	;//e
	.db 96, 82, 0, 156	;//r
	endasm

bounce_lost_ball:
	gosub pong_losesound //stealing it from the other game
	set bounce_loseball 0
	inc bounce_ballslost
	if bounce_ballslost = 3 then
		set bounce_endgame 1
		return
		endif
	set bounce_y 64
	set bounce_dx 0
	set bounce_gravdir 1 //0 = down, 1=up
	set bounce_gravindex 16
	return

//init vars
bounce_initvars:
	gosub clear_spritemem
	set bounce_endgame 0
	set bounce_loseball 0
	set bounce_ballslost 0
	set bounce_pad1x 8 //screen left
	set bounce_pad2x 223 //screen right - paddle width
	set bounce_x 18
	set bounce_y 8
	set bounce_dx 0
	set bounce_gravdir 0 //0 = down, 1=up
	set bounce_gravindex 0
	set bounce_score1 48 //ascii zero
	set bounce_score2 48
	set bounce_score3 48
	set bounce_frame 0
	set bounce_scroll 0

	//paddle y locations
	set [spritemem 0] 216
	set [spritemem 4] 216
	set [spritemem 8] 216
	set [spritemem 12] 216
	set [spritemem 16] 216
	set [spritemem 20] 216
	set [spritemem 28] 32 //score digit 1
	set [spritemem 32] 32 //score digit 2
	set [spritemem 36] 32 //score digit 3

	//tile numbers
	set [spritemem 1] 7
	set [spritemem 5] 8
	set [spritemem 9] 7
	set [spritemem 13] 7
	set [spritemem 17] 8
	set [spritemem 21] 7
	//set [spritemem 25] 88 //bouncing ball
	set [spritemem 41] 2 //head upper left
	set [spritemem 45] 3 //head upper right
	set [spritemem 49] 18 //head lower left
	set [spritemem 53] 19 //head lower right
	
	//attrib bytes
	set [spritemem 2] %10000010
	set [spritemem 6] %10000010
	set [spritemem 10] %11000010
	set [spritemem 14] %10000001
	set [spritemem 18] %10000001
	set [spritemem 22] %11000001
	set [spritemem 26] 0
	set [spritemem 30] 0 //score digit 1
	set [spritemem 34] 0 //score digit 2
	set [spritemem 38] 0 //score digit 3
	set [spritemem 42] 3 //head UL
	set [spritemem 46] 3 //head UR
	set [spritemem 50] 3 //head LL
	set [spritemem 54] 3 //head LR

	//x locations
	set [spritemem 31] 136 //score digit 1
	set [spritemem 35] 128 //score digit 2
	set [spritemem 39] 120 //score digit 3
	return

//handle joystick input
bounce_joyhandler:
	gosub joystick1
	gosub joystick2
	if joy1left = 1 if bounce_pad1x > 8 then
		dec bounce_pad1x
		dec bounce_pad1x
		endif
	if joy1right = 1 if + bounce_pad1x 24 < bounce_pad2x then
		inc bounce_pad1x
		inc bounce_pad1x
		endif
	if joy2left = 1 if + bounce_pad1x 24 < bounce_pad2x then
		dec bounce_pad2x
		dec bounce_pad2x
		endif
	if joy2right = 1 if bounce_pad2x < 223 then
		inc bounce_pad2x
		inc bounce_pad2x
		endif
	return

//handle the bouncing ball
bounce_physics:
//	set bounce_x 0
//	set bounce_y 8
//	set bounce_dx 0
//	set bounce_gravdir 0 //0 = down, 1=up
//	set bounce_gravindex 0

	set bounce_x + bounce_x bounce_dx
	if bounce_x < 12 then
		set bounce_x 12
		set bounce_dx - 0 bounce_dx
		endif
	if bounce_x > 236 then
		set bounce_x 236
		set bounce_dx - 0 bounce_dx
		endif

	//upward motion
	if bounce_gravdir = 1 then
		if bounce_gravindex = 0 then
			set bounce_gravdir 0
			return
			endif
		set bounce_y - bounce_y [bounce_gravity_array bounce_gravindex]
		dec bounce_gravindex
		return
		endif

	//downward motion
	if bounce_y >= 208 then //16 - ball height
		//either bounce or lose
		if bounce_x >= - bounce_pad1x 4 if bounce_x <= + bounce_pad1x 28 then
			//bounce off pad 1
			set bounce_gravdir 1
			set bounce_gravindex 45
			set bounce_dx - bounce_x - bounce_pad1x 4
			set bounce_dx [bounce_results bounce_dx]
			gosub bounce_incscore
			gosub bounce_playsound
			return
			endif
		if bounce_x >= - bounce_pad2x 4 if bounce_x <= + bounce_pad2x 28 then
			//bounce off pad 2
			set bounce_gravdir 1
			set bounce_gravindex 45
			set bounce_dx - bounce_x - bounce_pad2x 4
			set bounce_dx [bounce_results bounce_dx]
			gosub bounce_incscore
			gosub bounce_playsound
			return
			endif
		//LOSE
		set bounce_loseball 1
		return
		endif

	//move ball down
	set bounce_y + bounce_y [bounce_gravity_array bounce_gravindex]
	if bounce_gravindex < 63 inc bounce_gravindex
	return

//increment the 3-digit score
bounce_incscore:
	//if we overflow, then whatever. bugs are fun
	//note that ascii digits are 48-57
	inc bounce_score1
	if bounce_score1 = 58 then
		set bounce_score1 48
		inc bounce_score2
		endif
	if bounce_score2 = 58 then
		set bounce_score2 48
		inc bounce_score3
		endif
	return

//set the sprite locs and draw scene
bounce_draw:
	//draw the paddles
	set [spritemem 3] bounce_pad1x
	set [spritemem 7] + bounce_pad1x 8
	set [spritemem 11] + bounce_pad1x 16
	set [spritemem 15] bounce_pad2x
	set [spritemem 19] + bounce_pad2x 8
	set [spritemem 23] + bounce_pad2x 16
	//draw the score
	set [spritemem 29] bounce_score1
	set [spritemem 33] bounce_score2
	set [spritemem 37] bounce_score3
	//draw the ball
	//set [spritemem 24] bounce_y
	//set [spritemem 27] bounce_x
	set [spritemem 40] - bounce_y 8
	set [spritemem 43] - bounce_x 8
	set [spritemem 44] - bounce_y 8
	set [spritemem 47] bounce_x
	set [spritemem 48] bounce_y
	set [spritemem 51] - bounce_x 8
	set [spritemem 52] bounce_y
	set [spritemem 55] bounce_x

	gosub vwait
	set $2005 bounce_scroll
	set $2005 0
	set SPRITE_DMA 2
	inc bounce_frame
	if bounce_frame = 5 then
		inc bounce_scroll
		set bounce_frame 0
		endif
	return

//load the colors
bounce_palette:
	set $2006 $3f
	set $2006 0
	set x 0
	bounce_palette_1:
		set $2007 [bounce_palette_data x]
		inc x
		if x <> 32 branchto bounce_palette_1
	return	

bounce_playsound:
	//make a bouncing sound
	set $4000 %00000111
	set $4001 %10101011
	set $4002 %10101010
	set $4003 %11100001
	return

//load a pretty background
bounce_loadbg:
	gosub vwait
	gosub clear_palette
	gosub clear_background
	set bounce_row 4
	set bounce_sprite 96
	bounce_loadbg1:
		gosub vwait
		set $2006 $26
		set $2006 bounce_row
		//draw 10 tiles
		set $2007 bounce_sprite
		inc bounce_sprite
		set $2007 bounce_sprite
		inc bounce_sprite
		set $2007 bounce_sprite
		inc bounce_sprite
		set $2007 bounce_sprite
		inc bounce_sprite
		set $2007 bounce_sprite
		inc bounce_sprite
		set $2007 bounce_sprite
		inc bounce_sprite
		set $2007 bounce_sprite
		inc bounce_sprite
		set $2007 bounce_sprite
		inc bounce_sprite
		set $2007 bounce_sprite
		inc bounce_sprite
		set $2007 bounce_sprite
		inc bounce_sprite
		//now inc the row
		set bounce_sprite + bounce_sprite 6
		set bounce_row + bounce_row $20
		if bounce_row <> $c4 goto bounce_loadbg1		
	gosub vwait
	gosub bounce_palette
	return

bounce_results:
	asm
	.db 252, 252, 252, 253, 253, 253, 253, 254
	.db 254, 254, 254, 254, 255, 255, 255, 255
	.db 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4
	endasm

bounce_gravity_array: //64 bytes
	asm
	.db 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 2, 2
	.db 2, 2, 2, 2, 2, 3, 3, 2, 3, 2, 3, 3, 3, 3, 4, 4
	.db 3, 4, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4
	.db 3, 4, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4

	.db 0, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 1, 1, 1, 1, 1
	.db 1, 1, 1, 1, 1, 2, 1, 2, 1, 2, 2, 1, 2, 2, 2, 2
	.db 2, 2, 3, 2, 2, 3, 2, 3, 2, 3, 3, 3, 3, 3, 3, 3
	.db 3, 3, 3, 4, 3, 4, 3, 4, 4, 3, 4, 4, 4, 4, 4, 4
	endasm

bounce_palette_data:
	asm
	.db $22, $30, $26, $0e, $0e, $12, $22, $00, $0e, $16, $15, $00, $0e, $00, $30, $00
	.db $31, $16, $00, $00, $0e, $1a, $2a, $00, $0e, $16, $26, $00, $0e, $0e, $30, $00
	endasm
