// pong
//		2 player
// head bounce
// guess where his head is
//		three locations, guess where harold's head is
//		1st guess correct, +3 points
//		2nd guess correct, +1 point
//		keep going until you lose 3 times
//		track high score for the day
// rock paper scissors
//		each player presses a button
// quick draw!
//		players race to hit the A button after the screen bg color changes
// tic tac toe
// connect 4
// monte carlo (guess which cup the head is in)

array absolute $4014 SPRITE_DMA 0
array absolute $200 spritemem 256

//the program starts here on NES boot (see footer)
start:
	gosub vwait
	set $2000 %00000000
	set $2001 %00011100 //sprites and bg visible, no sprite clipping
	gosub init_vars
mainloop:
	gosub joy_handler
	gosub drawstuff
	goto mainloop

//set default sprite location
init_vars:
	gosub restart_game
	set palette_current_cycle 0
	set $4015 %101//enable square 1 and triangle
	return

//init all vars and draw stuff for restarting the menu
restart_game:
	//clear the screen
	gosub clear_palette
	gosub clear_spritemem
	gosub vwait
	set SPRITE_DMA 2
	//init vars
	set selected_game 0
	set select_pressed 0
	set inc_game 0
	set launch_game 0
	set [spritemem 0] 111
	set [spritemem 1] 1
	set [spritemem 2] 0
	set [spritemem 3] 72
	gosub load_main_bg
	gosub load_palette
	gosub vwait
	return

//routine to draw a sprite
drawstuff:
	//start with half a vwait
	asm
		lda $2002
		bpl drawstuff
	endasm
	//now set the palette
	gosub cycle_palette
	//now finish the vwait
	drawstuff_1:
		asm
		lda $2002
		bmi drawstuff_1
		lda #0
		sta $2005
		sta $2005
		sta $2006
		sta $2006
		endasm
	//gosub vwait
	//set $2003 0 //sprite memory loc 0
	//set $2004 + 111 << selected_game 3 //y
	//set $2004 1 //tile number
	//set $2004 0 //attrib
	//set $2004 72 //x
	//gosub load_palette
	set SPRITE_DMA 2
	//gosub cycle_palette
	return

//move sprite based on joystick input
joy_handler:
	gosub joystick1
	gosub incrementer
	if inc_game <> 0 then
		inc selected_game
		if selected_game = 2 set selected_game 0
		set [spritemem 0] + 111 << selected_game 3
		endif
	if launch_game <> 0 then
		if selected_game = 0 gosub pong_main
		if selected_game = 1 gosub bounce_main
		gosub restart_game
		endif
	return

//handle press and release of A/B buttons
incrementer:
	//handle select button
	set inc_game 0
	if joy1select = 0 set select_pressed 0
	if joy1select = 1 if select_pressed = 0 then
		set select_pressed 1
		set inc_game 1
		endif
	//handle start button
	set launch_game 0
	if joy1start = 0 if start_pressed = 1 then
		set start_pressed 0
		set launch_game 1
		endif
	if joy1start = 1 set start_pressed 1
	return

cycle_palette:
	inc current_frame
	if current_frame <> 5 return
	set current_frame 0
	set $2006 $3f
	set $2006 $11
	set main_temp [palette_cycle_data palette_current_cycle]
	//set $2007 [palette_cycle_data palette_current_cycle]
	set $2007 main_temp
	inc main_temp
	set $2007 main_temp
	inc palette_current_cycle
	if palette_current_cycle = 20 set palette_current_cycle 0
	return

palette_cycle_data:
	asm
	.db $01, $02, $03, $04, $05, $06, $07, $08, $09, $0a, $1a, $19, $18, $17, $16, $15, $14, $13, $12, $11
	endasm

//load the colors
load_palette:
	set $2006 $3f
	set $2006 0
	set x 0
	load_palette_1:
		set $2007 [palette_data x]
		inc x
		if x <> 32 branchto load_palette_1
	return	


//data section
// 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
// a  b  c  d  e  f  g  h  i  j  k  l  m  n  o  p  q  r  s  t  u  v  w  x  y  z
asm
palette_data:
	.db $0e, $30, $00, $00, $0e, $87, $18, $00, $0e, $30, $00, $00, $0e, $30, $00, $00
	.db $0e, $30, $00, $00, $0e, $30, $00, $00, $0e, $30, $00, $00, $0e, $30, $00, $00	
main_bg_text_1:
	.db 78,69,83,32,77,73,78,73,71,65,77,69,83 ;//"nes minigames"
	;//.db 79,78,69,32,87,69,69,75,32,79,70,32,78,69,83 ;//"one week of nes"
main_bg_text_2:
	.db 66,89,32,66,79,66,32,82,79,83,84 ;//"by bob rost"
main_bg_text_3:
	.db 80,79,78,71 ;//"pong"
main_bg_text_4:
	.db 72,69,65,68,32,66,79,85,78,67,69 ;//"head bounce"
main_bg_text_5:
	.db 67,72,79,79,83,69,32,87,73,84,72,32,83,69,76,69,67,84 ;//"choose with select" (18)
main_bg_text_6:
	.db 80,82,69,83,83,32,83,84,65,82,84,32,84,79,32,80,76,65,89 ;//"press start to play" (19)
endasm


load_main_bg:
	gosub clear_background
	//setup first text
	gosub vwait
	set $2006 $21
	set $2006 $09
	set x 0
	show_main_bg_text1:
		set $2007 [main_bg_text_1 x]
		inc x
		if x <> 13 branchto show_main_bg_text1
	//setup second text
	gosub vwait
	set $2006 $21
	set $2006 $2a
	set x 0
	show_main_bg_text2:
		set $2007 [main_bg_text_2 x]
		inc x
		if x <> 11 branchto show_main_bg_text2
	//setup third text
	gosub vwait
	set $2006 $21
	set $2006 $cb
	set x 0
	show_main_bg_text3:
		set $2007 [main_bg_text_3 x]
		inc x
		if x <> 4 branchto show_main_bg_text3
	//setup fourth text
	gosub vwait
	set $2006 $21
	set $2006 $eb
	set x 0
	show_main_bg_text4:
		set $2007 [main_bg_text_4 x]
		inc x
		if x <> 11 branchto show_main_bg_text4

	//setup fifth text
	gosub vwait
	set $2006 $23
	set $2006 $08
	set x 0
	show_main_bg_text5:
		set $2007 [main_bg_text_5 x]
		inc x
		if x <> 18 branchto show_main_bg_text5
	//setup sixth text
	gosub vwait
	set $2006 $23
	set $2006 $28
	set x 0
	show_main_bg_text6:
		set $2007 [main_bg_text_6 x]
		inc x
		if x <> 19 branchto show_main_bg_text6
	//ok, we're done
	return

